# coding=ISO-8859-1
from Screens.Screen import Screen
from Components.Button import Button
from Components.ServiceList import ServiceList
from Components.ActionMap import ActionMap
from Components.MovieList import MovieList
from Components.DiskInfo import DiskInfo
from Components.Label import Label
from Components.PluginComponent import plugins
from Plugins.Plugin import PluginDescriptor
from Plugins.Extensions.NoadService.Queue import Queue
from Components.config import config

from Screens.MessageBox import MessageBox
from Screens.FixedMenu import FixedMenu
from Screens.ChoiceBox import ChoiceBox

from Tools.Directories import *
from Tools.BoundFunction import boundFunction

from enigma import eServiceReference, eServiceCenter, eTimer

from Screens.MovieSelection import MovieSelection

import time
import socket
from ServiceReference import ServiceReference
from enigma import *

import os
import gettext
try:
	cat = gettext.translation('lang', '/usr/lib/enigma2/python/Plugins/Extensions/NoadService/po', [config.osd.language.getText()])
	_ = cat.gettext
except IOError:
	pass

class NoadMovieSelection(MovieSelection):
	
	def __init__(self, session, selectedmovie = None):
		self.skin = """
		<screen name="NoadMovieSelection" position="90,78" size="1120,910" title="%s">
			<widget name="waitingtext" position="0,0" size="1000,670" zPosition="2" font="Regular;22" />
			<widget name="list" position="0,0" size="1120,890" zPosition="1" scrollbarMode="showOnDemand" />
		</screen>""" % _("Select a movie")
		MovieSelection.__init__(self,session,selectedmovie)
		self.session = session
		
	def movieSelected(self):
		current = self.getCurrent()
		if current is not None:
			self.service = current
			serviceHandler = eServiceCenter.getInstance()
			offline = serviceHandler.offlineOperations(self.service)
			info = serviceHandler.info(self.service)
			name = info and info.getName(self.service) or _("this recording")
			result = False
			if offline is not None:
				# simulate first
				if not offline.deleteFromDisk(1):
					result = True
		
			if result == True:
				self.session.openWithCallback(self.noadConfirmed, MessageBox, _("Noad of %s realy start ?") % (name))
			else:
				self.session.openWithCallback(self.close, MessageBox, _("You cannot delete this!"), MessageBox.TYPE_ERROR)
				#self.session.open(NoadChannelContextMenu, self, current)
		#self.close()		
		
	def ReadLine(self,f):
		s = f.readline()
		s = str(buffer(s,0,len(s)-1))
		return s
			
	def LoadConfig(self):
		f = open("/hdd/noad/files/noad.conf")
		self.ip = self.ReadLine(f)
		self.port = int(self.ReadLine(f))
		f.close()
		
	def rpc(self):
		self.LoadConfig()
		addr = (self.ip,self.port)

		s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
		s.sendto("1",addr)
		
	def noadConfirmed(self, confirmed):
		if not confirmed:
			return self.close()
			
		serviceHandler = eServiceCenter.getInstance()
		#offline = serviceHandler.offlineOperations(self.service)
		info = serviceHandler.info(self.service)
		name = info.getName(self.service)
		service = ServiceReference(info.getInfoString(self.service, iServiceInformation.sServiceref))
		if service is not None:
			Kanal = service.getServiceName()
			begin = info.getInfo(self.service, iServiceInformation.sTimeCreate)
			sbegin = time.strftime("%Y%m%d %H%M - ",time.localtime(begin))
			Mes = sbegin + Kanal + " - " + name

			f = open("/hdd/noad/files/queue.txt","a")
			f.write(self.getFilename(Mes) + "\n")
			f.close()
			self.rpc()

			#self.session.open(MessageBox,Mes,type = MessageBox.TYPE_INFO,timeout = 10)
			
	def getFilename(self,basename):
		basename = basename.replace('\xc2\x86', '').replace('\xc2\x87', '')
		return basename
			
	def doContext(self):
		self.session.open(Queue)
		#self.close(True)		

