# coding=ISO-8859-1
from Screens.Screen import Screen
from Screens.MessageBox import MessageBox
from Components.config import *
from Components.ActionMap import ActionMap, NumberActionMap
from Components.ConfigList import ConfigList, ConfigListScreen
from Components.config import config
from Components.MenuList import MenuList
from Components.Button import Button
from Components.NimManager import nimmanager
from Components.Label import Label
from Components.Pixmap import Pixmap
from enigma import eTimer

import gettext
try:
	cat = gettext.translation('lang', '/usr/lib/enigma2/python/Plugins/Extensions/NoadService/po', [config.osd.language.getText()])
	_ = cat.gettext
except IOError:
	pass

class NoadSetup(Screen, ConfigListScreen):
	
	def __init__(self, session):
		self.skin = """
		<screen name="TVTVSetup" position="165,210" size="800,630" title="%s">
			<widget name="config" position="5,10" size="780,570" />
			<widget name="ok" position="90,500" size="53,40" pixmap="skin_default/buttons/green.png" alphatest="on" />
			<widget name="oktext" position="90,500" size="53,40" valign="center" halign="center" zPosition="1" font="Regular;20" backgroundColor="#1f771f" transparent="1" />
			<widget name="cancel" position="190,500" size="100,40" pixmap="skin_default/buttons/red.png" alphatest="on" />
			<widget name="canceltext" position="190,500" size="100,40" valign="center" halign="center" zPosition="1" font="Regular;20" backgroundColor="#1f771f" transparent="1" />
		</screen>""" % _("Noad service setup")
		Screen.__init__(self, session)
		
		self.noadTimer = eTimer()
		
		self.ip = ""
		self.port = ""
		self.idx = 0
		self.scene = 1
		self.overlap = 1
		self.ac3 = 1
		self.jump = 1
		
		self["oktext"] = Label(_("OK"))
		self["canceltext"] = Label(_("Cancel"))
		self["ok"] = Pixmap()
		self["cancel"] = Pixmap()

		self.LoadConfig()
		self.createConfig()

		self["actions"] = NumberActionMap(["SetupActions", "TextEntryActions"],
		{
			"ok": self.keySelect,
			"save": self.keyGo,
			"cancel": self.keyCancel,
			"left": self.keyLeft,
			"right": self.keyRight,
			"delete": self.keyDelete,
			"1": self.keyNumberGlobal,
			"2": self.keyNumberGlobal,
			"3": self.keyNumberGlobal,
			"4": self.keyNumberGlobal,
			"5": self.keyNumberGlobal,
			"6": self.keyNumberGlobal,
			"7": self.keyNumberGlobal,
			"8": self.keyNumberGlobal,
			"9": self.keyNumberGlobal,
			"0": self.keyNumberGlobal
		}, -1)

		self.list = []
		ConfigListScreen.__init__(self, self.list, session = session)
		self.createSetup("config")

	def ReadLine(self,f):
		s = f.readline()
		if (s):
			s = str(buffer(s,0,len(s)-1))
		return s
			
	def Message(self):
		self.session.open(MessageBox,_("Configurationerror:\n\nThe faild parameters would be set to default values !"),type = MessageBox.TYPE_ERROR)
			
	def SaveConfig(self):
		self.noadTimerConnect = self.noadTimer.timeout.connect(self.Message)
		self.noadTimer.start(10, True)
		f = open("/hdd/noad/files/noad.conf","w")
		f.write("localhost\n")
		f.write("25252\n")
		f.write("0\n")
		f.write("1\n")
		f.write("1\n")
		f.write("1\n")
		f.write("1\n")
		f.close()
		self.ip = "localhost"
		self.port = "25252"
		self.idx = 0
		self.scene = 1
		self.overlap = 1
		self.ac3 = 1
		self.jump = 1
		
	def LoadConfig(self):
		try:
			f = open("/hdd/noad/files/noad.conf")
			self.ip = self.ReadLine(f)
			self.port = self.ReadLine(f)
			idx = self.ReadLine(f)
			scene = self.ReadLine(f)
			overlap = self.ReadLine(f)
			ac3 = self.ReadLine(f)
			jump = self.ReadLine(f)
			f.close()
			try:
				p = int(self.port)
				self.idx = int(idx)
				self.scene = int(scene)
				self.overlap = int(overlap)
				self.ac3 = int(ac3)
				self.jump = int(jump)
			except:
				self.SaveConfig()
		except:
			self.SaveConfig()

	def createConfig(self):
		self.noad_ip = ConfigText(default = self.ip, fixed_size = False)
		self.noad_port = ConfigText(default = self.port, fixed_size = False)
		self.noad_idx = ConfigSelection(default = {0: _("no"), 1: _("yes")}[self.idx], choices = [_("no"),_("yes")])
		self.noad_scene = ConfigSelection(default = {0: _("no"), 1: _("yes")}[self.scene], choices = [_("no"),_("yes")])
		self.noad_overlap = ConfigSelection(default = {0: _("no"), 1: _("yes")}[self.overlap], choices = [_("no"),_("yes")])
		self.noad_ac3 = ConfigSelection(default = {0: _("no"), 1: _("yes")}[self.ac3], choices = [_("no"),_("yes")])
		self.noad_jump = ConfigSelection(default = {0: _("no"), 1: _("yes")}[self.jump], choices = [_("no"),_("yes")])

	def createSetup(self, widget):
		self.list = []
		self.list.append(getConfigListEntry(_("Hostname or IP-address:"), self.noad_ip))
		self.list.append(getConfigListEntry(_("Port:"), self.noad_port))
		self.list.append(getConfigListEntry(_("Generate Indexfile:"), self.noad_idx))
		self.list.append(getConfigListEntry(_("Recognize scenes :"), self.noad_scene))
		self.list.append(getConfigListEntry(_("Recognize overlaps :"), self.noad_overlap))
		self.list.append(getConfigListEntry(_("Recognize AC3 :"), self.noad_ac3))
		self.list.append(getConfigListEntry(_("Recognize jumping logos:"), self.noad_jump))

		self[widget].list = self.list
		self[widget].l.setList(self.list)

	def keySelect(self):
		self.keyGo()

	def keyGo(self):
		if (self.noad_idx.value == _("yes")):
			self.idx = 1
		else:
			self.idx = 0
		if (self.noad_scene.value == _("yes")):
			self.scene = 1
		else:
			self.scene = 0
		if (self.noad_overlap.value == _("yes")):
			self.overlap = 1
		else:
			self.overlap = 0
		if (self.noad_ac3.value == _("yes")):
			self.ac3 = 1
		else:
			self.ac3 = 0
		if (self.noad_jump.value == _("yes")):
			self.jump = 1
		else:
			self.jump = 0
		try:
			p = int(self.noad_port.value)
			if ((p > 0) and (p <= 65000)):
				f = open("/hdd/noad/files/noad.conf","w")
				f.write(self.noad_ip.value + "\n")
				f.write(self.noad_port.value + "\n")
				f.write(str(self.idx) + "\n")
				f.write(str(self.scene) + "\n")
				f.write(str(self.overlap) + "\n")
				f.write(str(self.ac3) + "\n")
				f.write(str(self.jump) + "\n")
				f.close()
				self.close((True, ))
			else:
				p /= 0;
		except ZeroDivisionError:
			self.session.open(MessageBox,_("Configurationerror:\n\nAlowed port numbers are between 1 and 65000 !"),type = MessageBox.TYPE_ERROR)		
		except:
			self.session.open(MessageBox,_("Configurationerror:\n\nPort is not a number !"),type = MessageBox.TYPE_ERROR)

	def keyCancel(self):
		self.close((False,))
