# coding=ISO-8859-1
from Components.HTMLComponent import *
from Components.GUIComponent import *
from Tools.FuzzyDate import FuzzyTime
from ServiceReference import ServiceReference
from Components.MultiContent import MultiContentEntryText
from Components.config import config

#from enigma import eListboxPythonMultiContent, eListbox, gFont, iServiceInformation, RT_HALIGN_LEFT, RT_HALIGN_RIGHT

#from enigma import eServiceReference, eServiceCenter, \
#	eServiceCenterPtr, iListableServicePtr, \
#	iStaticServiceInformationPtr
from enigma import *

import gettext
try:
	cat = gettext.translation('lang', '/usr/lib/enigma2/python/Plugins/Extensions/NoadService/po', [config.osd.language.getText()])
	_ = cat.gettext
except IOError:
	pass

class QueueList(HTMLComponent, GUIComponent):
	def __init__(self):
		GUIComponent.__init__(self)
		self.l = eListboxPythonMultiContent()
		#self.tags = set()
		#if root is not None:
		#	self.reload(root)
		self.l.setFont(0, gFont("Regular", 22))
		self.l.setFont(1, gFont("Regular", 18))
		self.l.setFont(2, gFont("Regular", 16))
		self.l.setBuildFunc(self.buildMovieListEntry)
		self.load()
		
	#
	# | name of movie              |
	#
	def buildMovieListEntry(self, Name, Kanal, Begin, Status):
		#if serviceref.flags & eServiceReference.mustDescent:
		#	return None

		#if len > 0:
		#	len = "%d:%02d" % (len / 60, len % 60)
		#else:
		#	len = "?:??"

		res = [ None ]

		res.append(MultiContentEntryText(pos=(0, 0), size=(840, 60), font = 0, flags = RT_HALIGN_LEFT, text = Name))
		res.append(MultiContentEntryText(pos=(640, 0), size=(400, 60), font = 2, flags = RT_HALIGN_RIGHT, text = Status))
		res.append(MultiContentEntryText(pos=(0, 30), size=(1120, 40), font=1, flags=RT_HALIGN_LEFT, text=Kanal))
		res.append(MultiContentEntryText(pos=(0, 50), size=(540, 40), font=1, flags=RT_HALIGN_LEFT, text=Begin))
		#res.append(MultiContentEntryText(pos=(290, 50), size=(270, 20), font=1, flags=RT_HALIGN_RIGHT, text=Status))
		#service = ServiceReference(info.getInfoString(serviceref, iServiceInformation.sServiceref))
		#if service is not None:

		#description = info.getInfoString(serviceref, iServiceInformation.sDescription)

		#begin_string = ""
		#if begin > 0:
		#	t = FuzzyTime(begin)
		#	begin_string = t[0] + ", " + t[1]


		return res

	def moveToIndex(self, index):
		self.instance.moveSelectionTo(index)

	def getCurrentIndex(self):
		return self.instance.getCurrentIndex()

	def getCurrentEvent(self):
		l = self.l.getCurrentSelection()
		return l and l[0] and l[1] and l[1].getEvent(l[0])

	def getCurrent(self):
		l = self.l.getCurrentSelection()
		return l and l[0]

	GUI_WIDGET = eListbox
	
	def postWidgetCreate(self, instance):
		instance.setContent(self.l)
		instance.setItemHeight(75)
	
	#def reload(self, root = None, filter_tags = None):
	#	if root is not None:
	#		self.load(root, filter_tags)
	#	else:
	#		self.load(self.root, filter_tags)
	#	self.l.setList(self.list)

	#def removeService(self, service):
	#	for l in self.list[:]:
	#		if l[0] == service:
	#			self.list.remove(l)
	#	self.l.setList(self.list)

	def __len__(self):
		return len(self.list)

	#def updateLengthOfIndex(self, index):
	#	if len(self.list) > index:
	#		x = self.list[index]
	#		self.list[index] = (x[0], x[1], x[2], x[1].getLength(x[0]))
	#		self.l.invalidateEntry(index)

	def ReadLine(self,f):
		s = f.readline()
		if (s):
			s = str(buffer(s,0,len(s)-1))
		return s

	def Split(self,s,status):
		sp = s.split(" - ",2);
		i = 0
		zeit = sp[0]
		kanal = sp[1]
		name = sp[2]
		#for tmp in sp:
		#	if (i > 3):
		#		name += " - " + tmp
		#	i += 1
		Jahr = zeit[0:4]
		Monat = zeit[4:6]
	 	Tag = zeit[6:8]
	 	Std = zeit[9:11]
	 	Min = zeit[11:13]
	 	hZeit = Tag + "." + Monat + "." + Jahr + " " + Std + ":" + Min
		return (name,kanal,hZeit,status)
			
	def ReadFertigEntry(self,f):
		s = self.ReadLine(f)
		if (s):
			self.ReadFertigEntry(f)
			self.list.append(self.Split(s, _("Noad is ready")))
			
	def ReadFertig(self):
		try:
			f = open("/hdd/noad/files/fertig.txt")
			if (f):
				self.ReadFertigEntry(f)
				f.close()
		except:
			pass
			
	def ReadQueueEntry(self,f):
		s = self.ReadLine(f)
		if (s):
			self.ReadQueueEntry(f)
			self.list.append(self.Split(s, _("waiting to start noad")))
			
	def ReadQueue(self):
		try:
			f = open("/hdd/noad/files/queue.txt")
			if (f):
				self.ReadQueueEntry(f)
				f.close()
		except:
			pass

	def ReadInBearbeitung(self):
		try:
			f = open("/hdd/noad/files/in_bearbeitung.txt")
			if (f):
				s = self.ReadLine(f)
				if (s):
					self.list.append(self.Split(s, _("Noad is activ")))
				f.close()
		except:
			pass

	def load(self):		
		self.list = [ ]
		self.ReadQueue()
		self.ReadInBearbeitung()
		self.ReadFertig()
		self.l.setList(self.list)

	#def moveTo(self, serviceref):
	#	found = 0
	#	count = 0
	#	for x in self.list:
	#		if x[0] == serviceref:
	#			found = count
	#		count += 1
	#	self.instance.moveSelectionTo(found)

	def moveDown(self):
		self.instance.moveSelection(self.instance.moveDown)
	